#ifndef GET_FILE
#define GET_FILE

#include <iostream>
#include <fstream>

#include <p2pvdn/socket.h>
#include <p2pvdn/hash.h>
#include <p2pvdn/file_opts.h>
#include <p2pvdn/peer.h>

#include <chord.h>

namespace get_file {
	struct opts;

	struct ctx {
		std::ostream *output;
		private:
		std::ofstream fstream;
		public:
		p2pvdn::hash hash;
		p2pvdn::file_opts file_opts;
		int used_peers;
		std::vector<std::pair<p2pvdn::node, unsigned>> peers;
		struct chord_node gw_node;

		ctx(const opts &);
	};
}

namespace stream {
	template<unsigned> void stream(get_file::ctx &);
}

#endif
