#ifndef PEER_DATA_H
#define PEER_DATA_H

#include <p2pvdn/socket.h>
#include <p2pvdn/peer.h>

#include <boost/thread/shared_mutex.hpp>

#include <map>
#include <iostream>

namespace vdnd {
	class peer_data {
		mutable boost::shared_mutex mutex;
		std::map<p2pvdn::node, unsigned> peers;

		public:
		friend const p2pvdn::socket &operator>>(const p2pvdn::socket &, peer_data &);
		friend const p2pvdn::socket &operator<<(const p2pvdn::socket &, const peer_data &);
		friend std::ostream &operator<<(std::ostream &, const peer_data &);
	};

	const p2pvdn::socket &operator>>(const p2pvdn::socket &, peer_data &);
	const p2pvdn::socket &operator<<(const p2pvdn::socket &, const peer_data &);

	std::ostream &operator<<(std::ostream &stream, const peer_data &);
}

#endif
